hitboxes = {}
decor = {}
function decor_update(dt)

end

function decor_draw()
	--for i,v in ipairs(hitboxes) do
		--love.graphics.rectangle("line",v.x,v.y,v.w,v.h)
	--end
	for i,v in ipairs(decor) do
		if(v.x + v.w > -cam.x and v.y + v.h> -cam.y and v.x - v.w < -cam.x + screen.w and v.y - v.h < -cam.y + screen.h) then 
			love.graphics.draw(v.img,v.x,v.y)
		end
	end
end

function hitbox_col2(x1,y1,dx,dy,x2,y2,w,h,dt)
	if(x1 > x2 and x1 < x2 + w) then
		if(y1 < y2 and y1 + dy * dt > y2) then
			y1 = y2 - 1
			--y1 = 0
			dy = 0
		end
	
		if(y1 > y2 and y1 + dy * dt < y2 + h) then
			y1 = y2 + h + 1
			--y1 = 0
			dy = 0
		end
	end
	
	if(y1 > y2 and y1 < y2 + h) then
		if(x1 > x2 and x1 + dx * dt < x2 + w) then
			x1 = x2 + w + 1
			dx = 0
		end
		
		if(x1 < x2 and x1 + dx * dt > x2) then
			x1 = x2 - 1
			dx = 0
		end
	end
	
	return x1,y1,dx,dy	
end

function hitbox_col(x,y,dx,dy,dt)
	for i,v in ipairs(hitboxes) do	
		if(x > v.x and x < v.x + v.w) then
			if(y < v.y and y + dy * dt > v.y) then
				y = v.y - 1
				dy = 0
			end
		
			if(y > v.y and y + dy * dt < v.y + v.h) then
				y = v.y + v.h + 1
				dy = 0
			end
		end
		
		if(y > v.y and y < v.y + v.h) then
			if(x > v.x and x + dx * dt < v.x + v.w) then
				x = v.x + v.w + 1
				dx = 0
			end
			
			if(x < v.x and x + dx * dt > v.x) then
				x = v.x - 1
				dx = 0
			end
		end
		
	end
	
	return x,y,dx,dy
end

function en_col(x,y,dx,dy,i,dt)
	
	for j,v in ipairs(en) do
		if(i ~= j) then
			if(CheckCollision(x-enW/2,y+(dy*dt)-enH/2,enW,enH,v.x-enW/2,v.y-enH/2,enW,enH)) then
				if(dy > 0) then
					y = y-1
				else
					y = y + 1
				end
				dy = 0
			end
			if(CheckCollision(x+(dx*dt)-enW/2,y-enH/2,enW,enH,v.x-enW/2,v.y-enH/2,enW,enH)) then
				if(dx > 0) then
					x = x -1
				else
					x = x + 1
				end
				dx = 0
			end
		end
	end
	return x,y,dx,dy
end

desk = love.graphics.newImage("gfx/desk.png")
cooler = love.graphics.newImage("gfx/cooler.png")

function decorate(ro,lastDir,dir,doorType) -- -- 1:up, 2:right, 3:down, 4:left -- 1:small 2:big
	if(doorType == 1 and ro.w > ro.h and lastDir == 2 and dir ~= 3) then
		local r = math.random(1,1)
		if(r == 1) then
			for i=0,math.floor(ro.w/200)-1 do
				local hb = {}
				local rx = ro.x + i*200+30
				local ry = ro.y + ro.h - 140
				hb.x = rx
				hb.y = ry
				hb.w = 150
				hb.h = 100
				
				table.insert(hitboxes,hb)
				
				local de = {}
				de.x = rx
				de.y = ry
				de.img = desk
				de.w = 150
				de.h = 100
				
				table.insert(decor,de)
			end
		end
	elseif(dir == 1) then
		local r = math.random(1,3)
		if(r == 1) then
			local de = {}
			de.x = ro.x + 40
			de.y = ro.y + 40
			de.w = 100
			de.h = 100
			de.img = cooler
			table.insert(decor,de)
			local hb = {}
			hb.x = ro.x + 40
			hb.y = ro.y + 40
			hb.w = 50
			hb.h = 100
			table.insert(hitboxes,hb)
		end
	end
end

function decor_reset()
	for i=#hitboxes,1,-1 do
		table.remove(hitboxes,i)
	end
	for i=#decor,1,-1 do
		table.remove(decor,i)
	end
end
