local flashes = {}
trail = {}

trails = {}

local trailTimer = 0
local trailWait = 0.2
local trailX = 0
local trailY = 0
local tw = 5
local trailVel = 800

local blood = {}

local parts = {}
local bloodE1 = love.graphics.newImage("gfx/blood2.png")
local bloodE2 = love.graphics.newImage("gfx/blood3.png")
local bloodE3 = love.graphics.newImage("gfx/blood4.png")

local shells = {}
local shell = love.graphics.newImage("gfx/shell.png")

function effects_update(dt)
	-- Trail
	local ltx = trailX -- last trail x
	local lty = trailY
	trailX = player.x
	trailY = player.y
	if not(trailX == ltx or trailY == lty ) then
		if(math.abs(player.xvel) + math.abs(player.yvel) > trailVel) then
			trailTimer = trailTimer - 1 * dt
		else
			if(#trail>1) then
				trail[#trail].fin = true
			end		
		end
	else
		if(#trail>1) then
			trail[#trail].fin = true
		end
	end
	if(trailTimer < 0) then
		tr = {}
		tr.x = player.x
		tr.y = player.y
		table.insert(trail,tr)
		trailTimer = trailTimer + trailWait
	end
	-- Flashes
	for i,v in ipairs(flashes) do
		v.r = v.r + v.inc * dt
		v.timer = v.timer - 1 * dt
		if(v.timer <= 0) then
			table.remove(flashes,i)
		end
	end
	--Blood
	for i,v in ipairs(blood) do
		if(v.vel > 0) then
			local dx = math.cos(v.a) * v.vel
			local dy = math.sin(v.a) * v.vel
			v.vel = v.vel - bloodDeacc * dt
			
			v.x,v.y,dx,dy = map_col(v.x,v.y,dx,dy,dt)
			
			v.x = v.x + dx * dt
			v.y = v.y + dy * dt
			
			if(v.w < 1) then
			v.w = v.w + 1 * dt
			v.h = v.h + 1 * dt
			end
			
		end
	end
	texts_update(dt)
	parts_update(dt)
	for i,v in ipairs(shells) do
		if not(v.timer) then
			v.timer = 1
		end
		if(v.timer > 0) then
			v.timer = v.timer - 1 * dt
			
			local dx = math.cos(v.a) * 300 * v.timer
			local dy = math.sin(v.a) * 300 * v.timer
			
			v.x,v.y,dx,dy = map_col(v.x,v.y,dx,dy,dt)
			
			v.x = v.x + dx * dt
			v.y = v.y + dy * dt
			
			v.da = v.da + 1 * dt
		end
		
	end
	
	for i,v in ipairs(trails) do
		if not(v.trail) then
			v.trail = {}
			for i=1,v.length do
				local tr = {}
				tr.x = v.x
				tr.y = v.y
				table.insert(v.trail,tr)
			end
		end
		if not(v.parent) then
			table.remove(trails,i)
		end
		if(v.parent.removeTrail == true) then
			table.remove(trails,i)
		end
		
		v.x = v.parent.x
		v.y = v.parent.y
		
		v.updateTimer = v.updateTimer - 1 * dt
		if(v.updateTimer < 0) then
			for i=#v.trail,1,-1 do
				if(i ~= 1) then
					local k = v.trail[i]
					local j = v.trail[i-1]
					k.x = j.x
					k.y = j.y
				else
					local k = v.trail[i]
					k.x = v.x
					k.y = v.y
				end
			end
			v.updateTimer = v.updateTimer + 0.005
		end
	end
end
bloodDeacc = 300

function blood_splat(x,y,am,range,typ)
	if(typ == "splat") then
		for i=1,am do
			local bl = {}
			bl.x = x
			bl.y = y
			bl.w = math.random(1,5)/10
			bl.h = bl.w
			bl.vel = math.random(200,400)
			bl.a = math.random(range[1]*100,range[2]*100)/100
			bl.typ = "splat"
			table.insert(blood,bl)
		end
	elseif(typ == "cone") then
			local bl = {}
			bl.x = x
			bl.y = y
			bl.w = math.random(1,5)/10
			bl.h = bl.w
			bl.vel = math.random(100,150)
			bl.a = math.random(range[1]*100,range[2]*100)/100
			bl.typ = "cone"
			table.insert(blood,bl)	
	elseif(typ == "big") then
			local bl = {}
			bl.x = x
			bl.y = y
			bl.w = math.random(1,5)/10
			bl.h = bl.w
			bl.vel = 0
			bl.a = math.random(range[1]*100,range[2]*100)/100
			bl.typ = "big"
			table.insert(blood,bl)	
	end
end

function trail_draw()
	love.graphics.setColor(20,20,20)
	for i,v in ipairs(trail) do
		--love.graphics.rectangle("fill",v.x,v.y,2,2)
		if(i ~= #trail) then	
			j = trail[i+1]
			if(v.x > -cam.x and v.y > -cam.y and v.x < -cam.x + screen.w and v.y < -cam.y + screen.h
			or j.x > -cam.x and j.y > -cam.y and j.x < -cam.x + screen.w and j.y < -cam.y + screen.h) then
				if not(v.fin) then
					love.graphics.line(v.x - tw,v.y -tw,j.x-tw,j.y-tw)
					love.graphics.line(v.x + tw,v.y + tw,j.x + tw,j.y + tw)
					love.graphics.line(v.x + tw*2,v.y + tw*2,j.x + tw*2,j.y + tw*2)
					love.graphics.line(v.x - tw*2,v.y - tw*2,j.x - tw*2,j.y - tw*2)
				end
			end
		else
			if not(v.fin) then
				love.graphics.line(v.x - tw,v.y -tw,player.x-tw,player.y-tw)
				love.graphics.line(v.x + tw,v.y + tw,player.x+tw,player.y+tw)
				love.graphics.line(v.x - tw*2,v.y -tw*2,player.x-tw*2,player.y-tw*2)
				love.graphics.line(v.x + tw*2,v.y + tw*2,player.x+tw*2,player.y+tw*2)
			end
		
		end
	end
	love.graphics.setColor(255,255,255)
end

function effects_draw()
	for i,v in ipairs(flashes) do
		love.graphics.circle("fill",v.x,v.y,v.r)
	end
	
	for i,v in ipairs(trails) do
		if(v.trail) then
			for i=1,#v.trail do
				local k = v.trail[i]
				local w = (i-v.length)/v.length*v.w
				local h = (i-v.length)/v.length*v.h
				love.graphics.rectangle("fill",k.x-w/2,k.y-h/2,w,w)
			end
		end
	end
	
	texts_draw()
	parts_draw()
end

function add_trails(x,y,w,h,length,parent)
	local tra = {}
	tra.x = x
	tra.y = y
	tra.w = w
	tra.h = h
	tra.length = length
	tra.parent = parent
	tra.updateTimer = 0.1
	table.insert(trails,tra)
end

function removeTrail(k)
	for i,v in ipairs(trails) do
		if(v.parent == k) then
			table.remove(trails,i)
		end
	end
end


function blood_draw()
	--love.graphics.setColor(255,0,0)
	for i,v in ipairs(blood) do
		if(v.x > -cam.x and v.y > -cam.y and v.x < -cam.x + screen.w and v.y < -cam.y + screen.h) then
			--love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
			if(v.typ == "splat") then
				love.graphics.draw(bloodE2,v.x,v.y,v.a)
			elseif(v.typ == "cone") then
				love.graphics.draw(bloodE3,v.x,v.y,v.a)
			elseif(v.typ == "big") then
				love.graphics.draw(bloodE1,v.x,v.y,v.a,1,1,50,50)
			end
			
		end
	end
	--love.graphics.setColor(255,255,255)
	
	for i,v in ipairs(shells) do
		if(v.x > -cam.x and v.y > -cam.y and v.x < -cam.x + screen.w and v.y < -cam.y + screen.h) then
			love.graphics.draw(shell,v.x,v.y,v.da)
		end
	end
end

function blood_reset()
	for i=#blood,1,-1 do
		table.remove(blood,i)
	end
	for i=#shells,1,-1 do
		table.remove(shells,i)
	end
	for i=#trails,1,-1 do
		table.remove(trails,i)
	end
end

function shell_add(x,y,a)
	sh = {}
	sh.x = x
	sh.y = y
	sh.a = a
	sh.da = a
	table.insert(shells,sh)
end

texts = {}

function texts_update(dt)
	for i,v in ipairs(texts) do
		v.x = v.x + v.dx * v.timer * dt
		v.y =v.y + v.dy * v.timer * dt
		
		v.timer = v.timer - 1 * dt
		if(v.timer < 0) then
			table.remove(texts,i)
		end
	end
end

function parts_update(dt)
	for i,v in ipairs(parts) do
		local dx = math.cos(v.a) * (v.vel*v.timer)
		local dy = math.sin(v.a) * (v.vel*v.timer)
		v.x = v.x + dx * dt
		v.y = v.y + dy * dt
		
		
		v.timer = v.timer - 1 * dt
		
		if(v.timer < 0) then
			table.remove(parts,i)
		end
	end
end

function parts_draw()
	for i,v in ipairs(parts) do
		love.graphics.setColor(v.r,v.g,v.b)
		love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
	end
	love.graphics.setColor(255,255,255)
end

function parts_add(x,y,w,h,am,range,vel,timer,rgb)
	for i=1,am do
		pa = {}
		pa.x = x
		pa.y = y
		pa.a = math.random(range[1]*100,range[2]*100)/100
		pa.w = w
		pa.h = h
		pa.vel = vel
		pa.timer = math.random(timer[1]*100,timer[2]*100)/100
		pa.r, pa.g, pa.b = rgb[1],rgb[2],rgb[3]
		table.insert(parts,pa)
	end
end

function text_add(t,x,y,dx,dy)
	te = {}
	te.text = t
	te.x = x
	te.y = y
	te.dx = dx
	te.dy = dy
	te.timer = 1
	
	table.insert(texts,te)
	
end

function texts_draw()
	love.graphics.setFont(font2)
	for i,v in ipairs(texts) do
		love.graphics.print(v.text,v.x,v.y)
	end
	love.graphics.setFont(font1)
end

function add_score(p)
	score = score + p*combo
	if(combo < maxCombo) then
		combo = combo + 1
	end
	comboTimer = comboTime
	
	text_add(p.." X "..combo,player.x - 50,player.y,math.random(-200,200),-math.random(400,800))
end

function add_flash(x,y,r,inc,t)
	fl = {}
	fl.x = x
	fl.y = y
	fl.r = r
	fl.timer = t
	fl.inc = inc
	
	table.insert(flashes,fl)
end

function pinhole_draw()
	love.graphics.draw(hole,screen.w/2,screen.h/2,0,holeS,holeS,50,50)
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",0,0,screen.w,screen.h/2 - holeS * 50)
	love.graphics.rectangle("fill",0,screen.h-1,screen.w,-(screen.h/2 - holeS * 50)+1)
	love.graphics.rectangle("fill",0,0,screen.w/2 - holeS * 50,screen.h)
	--love.graphics.rectangle("fill",screen.w,0,-(screen.w/2 - holeS * 50),screen.h)
	--love.graphics.rectangle("fill",screen.w,screen,-(screen.w/2 - holeS * 50),screen.h)
	love.graphics.rectangle("fill",screen.w/2 + holeS * 50,0,screen.w,screen.h)
	love.graphics.setColor(255,255,255)
end

local phSpeed = 5
local phMin = 1.5

hole = love.graphics.newImage("gfx/hole.png")
holeS = love.window.getHeight()/50

function pinhole_update(dt)
	if(holeS > phMin) then
		holeS = holeS - phSpeed * dt
	end
end
