en = {}
local en2 = {}
local en3 = {}
local en4 = {}

local enSpeed = 200
local enAcc = 100
local enRange = 900
enW = 32
enH = 52
local knockSpeed = 500

en2Firerate = 0.3
en2FollowTime = 3
en2ShootTime = 3

en3Speed = 100
en3KnockVel = 300

en4WaitTime = 0.4
en4PounceVel = 800
en4Deacc = 800
en4FollowTime = 3
en4Range = 100
en4Acc = 100
en4Vel = 700
en4TurnSpeed = 2

local squish = love.audio.newSource("sfx/squish.ogg")
local kill = love.audio.newSource("sfx/kill.ogg")
local damage = love.audio.newSource("sfx/damage.ogg")
function enemy_update(dt)
	for i,v in ipairs(en) do
		if not(v.vel) then
			v.vel = enSpeed/2
		end
		
		if(CheckCollision(v.x-enW/2-4,v.y-enH/2-4,enW-4,enH-4,player.x-16,player.y-26,32,52)) then
			if(math.abs(player.xvel) + math.abs(player.yvel) > knockSpeed) then
				local a = math.atan2((player.y - v.y),(player.x - v.x))

				body_drop(v.x,v.y,a)
				blood_splat(v.x,v.y,10,{a-0.5,a+0.5},"big")
				blood_splat(v.x,v.y,5,{0,6},"splat")
				add_score(10)
				loot_drop(v.x,v.y)
				table.remove(en,i)
				love.audio.play(squish)		
			elseif(v.vel > 0) then
				local a = math.atan2((player.y - v.y),(player.x - v.x))
				local dx = math.cos(a) * en3KnockVel
				local dy = math.sin(a) * en3KnockVel
				player.xvel = dx
				player.yvel = dy
				player.hp = player.hp - 1
				blood_splat(player.x,player.y,10,{0,6.2},"splat")
				love.audio.play(damage)
			end

			v.vel = 0
		else
			if(v.vel < enSpeed) then
				v.vel = v.vel + enAcc * dt
				if(v.vel > enSpeed) then v.vel = enSpeed end
			end		
		end
		
		en_follow(v,i,dt)

		en_wepDamage(v,i,en)
		en_bulletDamage(v,i,en)
		


	end
	
	for i,v in ipairs(en2) do
		if not(v.vel) then
			v.vel = enSpeed/2
		end
		
		if(CheckCollision(v.x-enW/2-4,v.y-enH/2-4,enW-4,enH-4,player.x-16,player.y-26,32,52)) then
			if(math.abs(player.xvel) + math.abs(player.yvel) > knockSpeed) then
				local a = math.atan2((player.y - v.y),(player.x - v.x))

				body_drop(v.x,v.y,a)
				blood_splat(v.x,v.y,10,{a-0.5,a+0.5},"big")
				blood_splat(v.x,v.y,5,{0,6},"splat")
				add_score(10)
				local r = math.random(1,25)
				if(r == 5) then
					pickup_drop(v.x,v.y,math.random(1,3))
				end
				table.remove(en2,i)
				love.audio.play(squish)		
			elseif(v.vel > 0) then
				local a = math.atan2((player.y - v.y),(player.x - v.x))
				local dx = math.cos(a) * en3KnockVel
				local dy = math.sin(a) * en3KnockVel
				player.xvel = dx
				player.yvel = dy
				player.hp = player.hp - 1
				blood_splat(player.x,player.y,3,{0,6.2},"splat")
				love.audio.play(damage)
			end

			v.vel = 0
		else
			if(v.vel < enSpeed) then
				v.vel = v.vel + enAcc * dt
				if(v.vel > enSpeed) then v.vel = enSpeed end
			end		
		end
		

		
		if(CheckDist(v.x,v.y,player.x,player.y) < enRange) then
			v.timer = v.timer - 1 * dt
			
			if(v.timer > 0) then 
				en_follow(v,i,dt)
			else
				v.cooldown = v.cooldown - 1 * dt
				if(v.cooldown < 0) then
					en_shoot(v.x,v.y)
					v.cooldown = en2Firerate
				end
				if(v.timer < -en2ShootTime) then
					v.timer = en2FollowTime
				end
			end
		
		end
		
		en_wepDamage(v,i,en2)
		en_bulletDamage(v,i,en2)

	end

	for i,v in ipairs(en3) do
		if not(v.vel) then
			v.vel = en3Speed/2
		end
		
		if(CheckCollision(v.x-enW/2-4,v.y-enH/2-4,enW-4,enH-4,player.x-16,player.y-26,32,52)) then
			if(v.vel > 0) then
				local a = math.atan2((player.y - v.y),(player.x - v.x))
				local dx = math.cos(a) * en3KnockVel
				local dy = math.sin(a) * en3KnockVel
				player.xvel = dx
				player.yvel = dy
				blood_splat(player.x,player.y,10,{0,6.2},"splat")
				player.hp = player.hp - 1
				love.audio.play(damage)
			end

			v.vel = 0
		else
			if(v.vel < en3Speed) then
				v.vel = v.vel + enAcc * dt
				if(v.vel > en3Speed) then v.vel = en3Speed end
			end		
		end
		

		en_follow(v,i,dt)

		
		en_bulletDamage(v,i,en3)

	end

	for i,v in ipairs(en4) do
		if not(v.angle) then
			v.angle = 0
		end
		en_bulletDamage(v,i,en4)
		en_wepDamage(v,i,en4)
		if(v.timer > 0 and v.pounced == false) then
			if(v.vel < en4Vel) then
				v.vel = v.vel + en4Acc * dt
			end
			if(CheckDist(v.x,v.y,player.x,player.y) < en4Range) then
				v.timer = 0
			end
			en_angleMove(v,dt)
			--en_follow(v,dt)
		elseif(v.pounced == false) then
			v.timer = v.timer - 1 * dt
			if(v.timer < -en4WaitTime) then
				if(v.pounced == false) then
					v.angle = math.atan2((v.y - player.y),(v.x - player.x)) +3.14
					v.vel = en4PounceVel
					v.pounced = true
				end
			end
		else
			v.dx = math.cos(v.angle) * v.vel
			v.dy = math.sin(v.angle) * v.vel
			
			local ldy = v.dy; local ldx = v.dx
			v.x,v.y,v.dx,v.dy = map_col(v.x,v.y,v.dx,v.dy,dt)
			if(ldy ~= v.dy or ldx ~= v.dx) then
				v.vel = 0
			elseif(v.hit == false) then
				if(CheckCollision(player.x-16,player.y-26,32,52,v.x-15,v.y-15,30,30)) then
					player.hp = player.hp - 2
					v.hit = true
					blood_splat(player.x,player.y,20,{v.angle-0.2,v.angle+0.2})
					love.audio.play(damage)
				end
			end
			
			v.x = v.x + v.dx * dt
			v.y = v.y + v.dy * dt
			v.vel = v.vel - en4Deacc * dt
			if(v.vel < 0) then
				v.timer = 1
				v.pounced = false
				v.hit = false
			end
		end	
	end
	
	for i,v in ipairs(enBullets) do
		if not(v.timer) then
			v.timer = 3
		end
		if(v.dx ~= 0 and v.dy ~= 0) then
			v.timer = v.timer - 1 * dt
			if(v.timer < 0) then
				table.remove(enBullets,i)
			end

			local lastdy = v.dy
			local lastdx = v.dx
			v.x,v.y,v.dx,v.dy = map_col(v.x,v.y,v.dx,v.dy,dt)
			v.x,v.y,v.dx,v.dy = hitbox_col(v.x,v.y,v.dx,v.dy,dt)
				
			if(lastdx ~= v.dx or lastdy ~= v.dy) then
				parts_add(v.x,v.y,10,10,10,{v.angle+3.54,v.angle+2.6},800,{0.2,0.4},{0,200,0})
			end
				
			v.x = v.x + v.dx * dt
			v.y = v.y + v.dy * dt
		end
	end
	
	for i,v in ipairs(bodies) do
		if(v.timer > 0) then
			v.timer = v.timer - 1 * dt
			local dx = math.cos(v.a) * v.vel * v.timer
			local dy = math.sin(v.a) * v.vel * v.timer
			
			v.x = v.x + dx * dt
			v.y = v.y + dy * dt
		end
	end
	

end

function en_reset()
	for i=#en,1,-1 do
		table.remove(en,i)
	end
	for i=#en2,1,-1 do
		table.remove(en2,i)
	end
	for i=#en3,1,-1 do
		table.remove(en3,i)
	end	
	for i=#en4,1,-1 do
		table.remove(en4,i)
	end	
end

function en_bulletDamage(v,i,tab)
	for j,k in ipairs(bullets) do
		if(v.dx ~= 0 and v.dy ~= 0) then
			if(CheckCollision(v.x-enW/2,v.y-enH/2,enW,enH,k.x,k.y,10,10)) then
				blood_splat(v.x,v.y,1,{k.angle-0.5,k.angle+0.5},"cone")
				blood_splat(v.x,v.y,5,{k.angle-0.5,k.angle+0.5},"splat")
				love.audio.play(kill)
				v.hp = v.hp - 1
				if(v.hp < 0) then
					local r = math.random(1,25)
					if(r == 5) then
						pickup_drop(v.x,v.y,math.random(1,3))
					end
					body_drop(v.x,v.y,k.angle)
					blood_splat(v.x,v.y,20,{k.angle-0.5,k.angle+0.5},"big")
					table.remove(tab,i)
					add_score(10)
				end
				
				k.removeTrail = true
				table.remove(bullets,j)
			end
		end
	end
end

function en_wepDamage(v,i,tab)
	for j,k in ipairs(weps) do
		if(k.vel > 0) then
			if(CheckCollision(v.x-enW/2,v.y-enH/2,enW,enH,k.x,k.y,100,50)) then
				blood_splat(v.x,v.y,5,{k.angle-0.5,k.angle+0.5},"splat")
				love.audio.play(kill)
				v.hp = v.hp - 5
				if(v.hp < 0) then
					loot_drop(v.x,v.y)
					body_drop(v.x,v.y,k.angle)
					blood_splat(v.x,v.y,20,{k.angle-0.5,k.angle+0.5},"big")
					table.remove(tab,i)
					add_score(5)
				end				
			end
		end
	end
end

function en_angleMove(v,dt)
	local targetA = math.atan2((v.y - player.y),(v.x - player.x)) + 3.14
	v.angle = smooth_rotate(targetA,v.angle,en4TurnSpeed,dt)
	local dx = math.cos(v.angle) * v.vel
	local dy = math.sin(v.angle) * v.vel
	
	v.x,v.y,dx,dy = map_col(v.x,v.y,dx,dy,dt)
	
	v.x = v.x + dx * dt
	v.y = v.y + dy * dt
end

function en_follow(v,i,dt)
		if(CheckDist(v.x,v.y,player.x,player.y) < enRange and los(player.x,player.y,v.x,v.y)) then
			local a = math.atan2((player.y - v.y),(player.x - v.x))
			local dx = math.cos(a) * v.vel
			local dy = math.sin(a) * v.vel
			
			v.x,v.y,dx,dy = map_col(v.x,v.y,dx,dy,dt)
			v.x,v.y,dx,dy = hitbox_col(v.x,v.y,dx,dy,dt)
			x,y,dx,dy = en_col(v.x,v.y,dx,dy,i,dt)
			
			if(math.abs(dx) > math.abs(dy)) then
				if(dx > 0) then
					v.pic = 5
				else
					v.pic = 4
				end
			else
				if(dy > 0) then
					v.pic = 2
				else
					v.pic = 3
				end
			end
			v.x = v.x + dx * dt
			v.y = v.y + dy * dt
		end	
end

enBullets = {}
enBulSpeed = 400
function en_shoot(x,y)
	local bu = {}
	bu.x = x
	bu.y = y
	local tx = player.x
	local ty = player.y
	bu.angle = math.atan2((ty - bu.y),(tx - bu.x))
	bu.dx = math.cos(bu.angle) * enBulSpeed
	bu.dy = math.sin(bu.angle) * enBulSpeed
	
	table.insert(enBullets,bu)
end

function en_spawn(x,y)
	if(floorNum > 1) then
		local enType = 0
		if(50/floorNum < 5) then
			enType = math.random(1,5)
		else
			enType = math.random(1,50/floorNum)
		end
			
		if(enType == 2) then
			e = {}
			e.x = x
			e.y = y
			e.hp = 2
			e.pic = 1
			e.timer = 3
			e.cooldown = 0
			table.insert(en2,e)
		elseif(enType == 3) then
			e = {}
			e.x = x
			e.y = y
			e.hp = 10
			e.pic = 1
			table.insert(en3,e)
		elseif(enType == 4) then
			e = {}
			e.x = x
			e.y = y
			e.hp = 5
			e.pic = 1
			e.pounced = false
			e.timer = 3
			e.vel = 100
			e.angle = 0
			e.hit = false
			table.insert(en4,e)			
		else
			e = {}
			e.x = x
			e.y = y
			e.hp = 2
			e.pic = 1
			table.insert(en,e)
		end
	else
		e = {}
		e.x = x
		e.y = y
		e.hp = 2
		e.pic = 1
		table.insert(en,e)	
	end
end

local enSprites = {}

enSprites[1] = love.graphics.newImage("gfx/en/z1.png")
enSprites[2] = love.graphics.newImage("gfx/en/z2.png")
enSprites[3] = love.graphics.newImage("gfx/en/z3.png")
enSprites[4] = love.graphics.newImage("gfx/en/z4.png")
enSprites[5] = love.graphics.newImage("gfx/en/z5.png")

local en2Sprites = {}

en2Sprites[1] = love.graphics.newImage("gfx/en2/z1.png")
en2Sprites[2] = love.graphics.newImage("gfx/en2/z2.png")
en2Sprites[3] = love.graphics.newImage("gfx/en2/z3.png")
en2Sprites[4] = love.graphics.newImage("gfx/en2/z4.png")
en2Sprites[5] = love.graphics.newImage("gfx/en2/z5.png")

local en3Sprites = {}

en3Sprites[1] = love.graphics.newImage("gfx/en3/z1.png")
en3Sprites[2] = love.graphics.newImage("gfx/en3/z2.png")
en3Sprites[3] = love.graphics.newImage("gfx/en3/z3.png")
en3Sprites[4] = love.graphics.newImage("gfx/en3/z4.png")
en3Sprites[5] = love.graphics.newImage("gfx/en3/z5.png")

local en4Sprites = {}
en4Sprites[1] = love.graphics.newImage("gfx/en4.png")

function enemy_draw()
	for i,v in ipairs(en) do
		if(v.x + enW > -cam.x and v.y + enH > -cam.y and v.x - enW < -cam.x + screen.w and v.y - enH < -cam.y + screen.h) then
			--love.graphics.rectangle("fill",v.x-enW/2,v.y-enH/2,enW,enH)
			love.graphics.draw(enSprites[v.pic],v.x-enW/2,v.y-enH/2)
			
			love.graphics.setColor(255,0,0); love.graphics.rectangle("fill",v.x,v.y,1,1); love.graphics.setColor(255,255,255)
		end
	end
	for i,v in ipairs(en2) do
		if(v.x + enW > -cam.x and v.y + enH > -cam.y and v.x - enW < -cam.x + screen.w and v.y - enH < -cam.y + screen.h) then
			--love.graphics.rectangle("fill",v.x-enW/2,v.y-enH/2,enW,enH)
			love.graphics.draw(en2Sprites[v.pic],v.x-enW/2,v.y-enH/2)
		end
	end
	
	for i,v in ipairs(en3) do
		if(v.x + enW > -cam.x and v.y + enH > -cam.y and v.x - enW < -cam.x + screen.w and v.y - enH < -cam.y + screen.h) then
			love.graphics.draw(en3Sprites[v.pic],v.x-enW/2,v.y-enH/2)
		end
	end
	
	
	for i,v in ipairs(en4) do
		--love.graphics.rectangle("fill",v.x-enW/2,v.y-enH/2,enW,enH)
		love.graphics.draw(en4Sprites[1],v.x,v.y,v.angle+math.pi/2,1,1,enW/2,enH/2)
	end
	love.graphics.setColor(0,200,0)
	for i,v in ipairs(enBullets) do
		if(v.x > -cam.x and v.y > -cam.y and v.x < -cam.x + screen.w and v.y < -cam.y + screen.h) then
			love.graphics.rectangle("fill",v.x,v.y,10,10)
		end
	end
	love.graphics.setColor(255,255,255)
end

bodies = {}
body = love.graphics.newImage("gfx/body.png")
function bodies_draw()
	for i,v in ipairs(bodies) do
		if(v.x > -cam.x and v.y > -cam.y and v.x < -cam.x + screen.w and v.y < -cam.y + screen.h) then
			love.graphics.draw(body,v.x,v.y,v.a+1.57,1,1,32/2,70/2)
		end
	end
end

function body_drop(x,y,a)
	bo = {}
	bo.x = x
	bo.y = y
	bo.a = a
	bo.vel = 100
	bo.timer = 1
	table.insert(bodies,bo)
end
