player.item = 0

slowmo = false
slowmoDuration = 5
slowmoTimer = 5

nofriction = false
nofrictionDuration = 5
nofrictionTimer = 5

boostVel = 1000

pickups = {}
weps = {}

item_icons = {}
item_icons[1] = love.graphics.newImage("gfx/items/icon1.png")
item_icons[2] = love.graphics.newImage("gfx/items/icon2.png")
item_icons[3] = love.graphics.newImage("gfx/items/icon3.png")
item_icons[4] = love.graphics.newImage("gfx/items/icon4.png")


function items_update(dt)
	if(slowmo == true) then
		slowmoTimer = slowmoTimer - 1 * (dt*slowdown)
		if(slowmoTimer < 0) then
			slowmo = false
		end
	end
	if(nofriction == true) then
		nofrictionTimer = nofrictionTimer - 1 * dt
		if(nofrictionTimer < 0) then
			nofriction = false
		end
	end
	
	for i,v in ipairs(pickups) do
		if(player.item == 0 and CheckCollision(player.x,player.y,32,52,v.x,v.y,v.w,v.h)) then
			player.item = v.item
			table.remove(pickups,i)
		end
	end
	
	for i,v in ipairs(weps) do
		if(v.vel > 0) then
			v.vel = v.vel - 100 * dt
			local dx = math.cos(v.angle) * v.vel
			local dy = math.sin(v.angle) * v.vel
			
			local ldx = dx; local ldy = dy
			v.x,v.y,dx,dy = map_col(v.x,v.y,dx,dy,dt)
			if(dx ~= ldx or dy ~= ldy) then
				if(dy > 0 and dx < 0) then
					v.angle = v.angle + 1.5
				else
					v.angle = v.angle - 1.5
				end
				v.vel = v.vel - 50
			end
			v.x = v.x + dx * dt
			v.y = v.y + dy *dt
		end
	end
end

function loot_drop(x,y)
	local r = math.random(1,25)
	if(r == 1) then
		pickup_drop(x,y,math.random(1,4))
	else
		r = math.random(1,100)
		if(r == 1) then
			r = math.random(3,6)
			local a = math.random(0,610)/100
			wep_drop(x,y,a,100,r)
		end
	end
end

function wep_drop(x,y,angle,vel,wepNum)
	we = {}
	we.x = x
	we.y = y
	we.angle = angle
	--we.dx = math.cos(angle) * vel
	--we.dy = math.sin(angle) * vel
	we.timer = 1
	we.wepNum = wepNum
	we.vel = vel
	table.insert(weps,we)
end

function pickup_drop(x,y,item)
	pi = {}
	pi.x = x
	pi.y = y
	pi.w = 20
	pi.h = 20
	pi.item = item
	
	table.insert(pickups,pi)
end

function items_draw()
	for i,v in ipairs(pickups) do
		love.graphics.draw(item_icons[v.item],v.x,v.y)
	end
	for i,v in ipairs(weps) do
		love.graphics.draw(gun,v.x,v.y,v.angle+1.6,1,1,25,5)
		--love.graphics.rectangle("fill",v.x,v.y,50,20)
	end
end

function items_HUD()
	love.graphics.setColor(0,200,0)
	if(slowmo == true) then
		local w = slowmoTimer/slowmoDuration * 80
		love.graphics.rectangle("fill",10,screen.h - 100,w,5)
	elseif(nofriction == true) then
		local w = nofrictionTimer/nofrictionDuration * 80
		love.graphics.rectangle("fill",10,screen.h - 100,w,5)	
	end
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("line",100, screen.h - 90,40,35)
	if(player.item > 0) then
		love.graphics.draw(item_icons[player.item],100, screen.h - 90)
	end
	
	love.graphics.setFont(font2)
	love.graphics.setColor(220,220,220)
	for i,v in ipairs(weps) do
		if(CheckCollision(player.x-16,player.y-26,32,52,v.x,v.y,100,50)) then
			local text = guns[v.wepNum].name
			local tw = font2:getWidth(text)
			love.graphics.print(guns[v.wepNum].name,screen.w/2 - tw/2,100)		
		end
	end
	love.graphics.setColor(255,255,255)
	love.graphics.setFont(font1)
end

function item_mousepress(x,y,button)
	if(button == "r") then
		item_use(player.item,x,y)
	end
end

function item_use(item,x,y)
	if(item == 0) then
	
	elseif(item == 1) then
		slowmo = true
		slowmoTimer = slowmoDuration
	elseif(item == 2) then
		nofriction = true
		nofrictionTimer = nofrictionDuration
	elseif(item == 3) then
		local tx = x -cam.x; local ty = y - cam.y
		local a = math.atan2((ty - player.y),(tx - player.x)) + 3.14
		player.yvel =  math.sin(a) * boostVel
		player.xvel = math.cos(a) * boostVel
	elseif(item == 4) then
		player.hp = player.hp + 3
		if(player.hp > 10) then
			player.hp = 10
		end
	end
	
	player.item = 0
end

function items_reset(full)
	for i=#pickups,1,-1 do
		table.remove(pickups,i)
	end
	for i=#weps,1,-1 do
		table.remove(weps,i)
	end
	if(full == true) then
		player.item = 0
		player.wep = {1,2}
		player.wepSel = 1
	end
end
