require "player"
require "effects"
require "map"
require "enemy"
require "state"
require "decor"
require "items"
require "light"
require "fade"


-- rem Office chairs yo, we got a thing

cam = {}
cam.x = 0
cam.y = 0
cam.tx = 0
cam.ty = 0
cam.speed = 5

screen = {}
screen.w = love.window.getWidth()
screen.h = love.window.getHeight()
slowdown = 4
function love.load()
	love.graphics.setDefaultFilter("linear", "linear")

	map_load()
	en_spawn(500,500)
	font1 = love.graphics.newFont(12)
	font2 = love.graphics.newFont(30)
	
	love.graphics.setBackgroundColor(20,0,0)
	
	gamePause = false
	
	--add_trails(0,0,20,40,40,player)
end


cTimer = 0
function love.update(dt)
	if(state == "play" and gamePause == false) then
		if(slowmo == true) then
			dt = dt/slowdown
		end
		
		if(nofriction == true) then
			friction = 0
		elseif(love.keyboard.isDown(" ")) then
			friction = 800
		else
			friction = 200
		end
		
		
		cTimer = cTimer + 3 * dt
		if(cTimer > 100) then
			cTimer = 0
		end
		local tc = math.cos(cTimer) * 10 + 10
		love.graphics.setBackgroundColor(tc,0,0)

		if(fadeDone()) then
			player_update(dt)
			enemy_update(dt)
			map_update(dt)
			effects_update(dt)
			decor_update(dt)
			items_update(dt)
			light_update(dt)
		end
		
	elseif(state == "menu") then
		menu_update(dt)
	elseif(state == "gameover") then
		gameover_update(dt)
	end
	
	fade_update(dt)
	if(fadeDone()) then
		cam.tx = -player.x +screen.w/2
		cam.ty = -player.y + screen.h/2
		cam.x = cam.x + ((cam.tx - cam.x) * cam.speed * dt)
		cam.y = cam.y + ((cam.ty - cam.y) * cam.speed * dt)
	end
end


function love.mousepressed(x,y,button)
	if(state == "play") then
		player_mousepress(x,y,button)
		item_mousepress(x,y,button)
	elseif(state == "gameover") then
	
	end
end
fs = false
function love.keypressed(key)
	if(key == "1") then
		if(fs == false) then
			
			love.window.setMode(0,0)
			love.window.setFullscreen(true)
			fs = true
			screen.w = love.window.getWidth()
			screen.h = love.window.getHeight()
		else
			love.window.setMode(1280,720)
			love.window.setFullscreen(false)
			fs = false
			screen.w = love.window.getWidth()
			screen.h = love.window.getHeight()
		end
	end
	if(key == "r") then reset() end
	--
	if(state == "play") then
		player_keypress(key)
		if(gamePause == true) then
			gamePause_keypress(key)
		end
		if(key == "escape") then
			if(gamePause == false) then
				gamePause = true
			else
				gamePause = false
			end
		end
	else
		if(key == "escape") then love.event.quit() end
	end
	if(state == "gameover") then
		gameover_keypress(key)
	end
	if(state == "menu") then
		menu_keypress(key)
	end
end

roof = {}

roof.ts = 100 -- tile size
c = 0
local lightAm = 0.25
function love.draw()
	--if(state == "play") then
	if not(state == "menu") then
		lighting()
	
		love.graphics.push()
		love.graphics.translate(cam.x,cam.y)

		map_draw()
		trail_draw()
		bodies_draw()
		blood_draw()
		map2_draw()
		player_draw()
		enemy_draw()
		map3_draw()
		decor_draw()
		items_draw()
		effects_draw()

		love.graphics.pop()
		
		lighting_2()
		
		love.graphics.setStencil(nil)
		
		player_HUD()
		items_HUD()
		love.graphics.print(math.floor(math.abs(player.xvel) + math.abs(player.yvel)),100,10)
		love.graphics.print(love.timer.getFPS(),10,10)
		--elseif(state == "gameover") then
	end
	if(state == "menu") then
		menu_draw()
	end
	if(state == "play") then
		if(gamePause == true) then
			gamePause_draw()
		end
	end
	if(state == "gameover") then
		gameover_draw()
	end
	--end
	
	fade_draw()
end

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)

  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function CheckDist(x1,y1,x2,y2)
	return math.sqrt((x2-x1)^2 + (y2-y1)^2)
end

function mouse_angle()
	local tx = love.mouse.getX() - cam.x
	local ty = love.mouse.getY() - cam.y
	return math.atan2((ty - player.y),(tx - player.x))
end

function smooth_rotate(goal, current, speed, dt)
	local diff = (goal-current+math.pi)%(2*math.pi)-math.pi --checking if there's a different between the goal and the current
	if(diff>speed*dt)then --this means that we still need to speed up
		return current + speed * dt 
	end
	if(diff<speed*-dt)then --and this means we need to slow down
		return current - speed * dt
	end
	return goal --if diff equals 0 then just return goal
end
