local p1 = love.graphics.newImage("gfx/p1.png")
local p2 = love.graphics.newImage("gfx/p2.png")
local p3 = love.graphics.newImage("gfx/p3.png")
local p4 = love.graphics.newImage("gfx/p4.png")
local p5 = love.graphics.newImage("gfx/p5.png")
local p6 = love.graphics.newImage("gfx/p6.png")
local p7 = love.graphics.newImage("gfx/p7.png")
local p8 = love.graphics.newImage("gfx/p8.png")


local s1 = love.audio.newSource("sfx/sfx.ogg")
local s2 = love.audio.newSource("sfx/sfx2.ogg")
local s3 = love.audio.newSource("sfx/sfx3.ogg")


player = {}
player.x = 200
player.y = 200

player.xvel = 0
player.yvel = 0

local moveSpeed = 100
local walkAcc = 400

player.w = 16 -- 32
player.h = 26 -- 52

friction = 200

player.hp = 10

bullets = {}

fireRate = 0.3
cooldown = 0

player.wep = {1,2}
player.wepSel = 1

guns = {}
guns[1] = {accuracy = 0.05, knockback = 70, bulSpeed = 600, fireRate = 0.12,spread = 1, shake = 10, name = "Rifle"}
guns[2] = {accuracy = 0.025, knockback = 400, bulSpeed = 600, fireRate = 0.6,spread = 1, shake = 10, name = "Super Pistol"}
guns[3] = {accuracy = 0.1, knockback = 70, bulSpeed = 600, fireRate = 0.1,spread = 1, shake = 50, name = "Super Rifle"}
guns[4] = {accuracy = 0.1, knockback = 120, bulSpeed = 600, fireRate = 0.8,spread = 3, shake = 55, name = "Shotgun"}
guns[5] = {accuracy = 0.05, knockback = 40, bulSpeed = 600, fireRate = 0.2,spread = 2, shake = 10, name = "Double Rifle"}
guns[6] = {accuracy = 0.2, knockback = 70, bulSpeed = 600, fireRate = 1.1,spread = 6, shake = 60, name = "Super Shotgun"}
guns[7] = {accuracy = 0.4, knockback = 35, bulSpeed = 600, fireRate = 0.2,spread = 20, shake = 20, name = "BFG 3000"}

for i=1,#guns do
	if(love.filesystem.exists("gfx/weps/icons/icon"..i..".png")) then
	guns[i].icon = love.graphics.newImage("gfx/weps/icons/icon"..i..".png")
	end
end

score = 0
comboTimer = 0
comboTime = 5
maxCombo = 15
combo = 1

local phrases = {
"I <3 Spreadsheets","x_x","PEW PEW","Do the collisions work yet?","I'll fix that later","The Good, The Bad And The Dead",
"I can't feel my legs", "Does the background work yet?", "Almost spilt my coffee", "I need a lie down", "Happy thoughts... Happy thoughts", "Acounting 101",
"Doge, guide me", "You didn't have to cut me off", "What is love?", "Zoinks Scoob", "I do what I want", "Don't hate me 'cause you aint me", "Oops", "Hi, I'd like to order a pizza",
"What the frog?", "I love my dog", "Many bug, such broke, so jank", "What the Egg"

}

local showPhrase = false
local phraseTimer = 60
local phraseWait = 60
local showTime = 5
local phrase = 0

gameTime = 0
local enBulKnock = 100


function player_update(dt)
	gameTime = gameTime + 1 * dt
	if(showPhrase == true) then
		phraseTimer = phraseTimer - 1 * dt
		if(phraseTimer < 0) then
			phraseTimer = phraseWait
			showPhrase = false
		end
	else
		phraseTimer = phraseTimer - 1 * dt
		if(phraseTimer < 0) then
			phrase = math.random(1,#phrases)
			showPhrase = true
			phraseTimer = showTime
		end
	end
	-- Combo
	if(combo > 1) then
		comboTimer = comboTimer - 1 * dt
		if(comboTimer < 0) then
			combo = 1
			comboTimer = comboTime
		end
	end
	-- Movement Left + right
	if(love.keyboard.isDown("a") and player.xvel > -moveSpeed) then
		if(player.xvel > -moveSpeed) then
			player.xvel = player.xvel - walkAcc * dt
		end
		
		if(player.xvel > 0) then
			player.xvel = player.xvel - friction * dt
		end
		
	elseif(love.keyboard.isDown("d") and player.xvel < moveSpeed) then
		if(player.xvel < moveSpeed) then
			player.xvel = player.xvel + walkAcc * dt
		end
		
		if(player.xvel < 0) then
			player.xvel = player.xvel + friction * dt
		end
	else
		if(player.xvel > 0) then
			player.xvel = player.xvel - friction * dt
			if(player.xvel < 0) then
				player.xvel = 0
			end
		elseif(player.xvel < 0) then
			player.xvel = player.xvel + friction * dt
			if(player.xvel > 0) then
				player.xvel = 0
			end
		end
	end
	
	-- Up + Down
	if(love.keyboard.isDown("w") and player.yvel > -moveSpeed) then
		if(player.yvel > -moveSpeed) then
			player.yvel = player.yvel - walkAcc * dt
		end
		if(player.yvel > 0) then
			player.yvel = player.yvel - friction * dt
		end
	elseif(love.keyboard.isDown("s") and player.yvel < moveSpeed) then
		if(player.yvel < moveSpeed) then
			player.yvel = player.yvel + walkAcc * dt
		end
		if(player.yvel < 0) then
			player.yvel = player.yvel + friction * dt
		end
	else
		if(player.yvel > 0) then
			player.yvel = player.yvel - friction * dt
			if(player.yvel < 0) then
				player.yvel = 0
			end
		elseif(player.yvel < 0) then
			player.yvel = player.yvel + friction * dt
			if(player.yvel > 0) then
				player.yvel = 0
			end
		end
	end
	
	--Animate
	--[[
	local a = mouse_angle()
	if(a > 0 and a < 3.14/2) then
		player.pic = p3
	elseif(a > 3.14/2 and a < 3.14) then
		player.pic = p1
	elseif(a > 3.14 and a < 3.14 + 3.14/2) then
		player.pic = p4
	else
		player.pic = p2
	end
	--local a = math.atan2((0 - player.yvel),(0 - player.xvel))
	]]

	local a = mouse_angle()
	local dx = math.cos(a)
	local dy = math.sin(a)
	if(math.abs(dx) > math.abs(dy)) then
		if(dx < 0) then
			player.pic = p4
		elseif(dx > 0) then
			player.pic = p3	
		end
		
	else
		if(dy < 0) then
			player.pic = p2
		elseif(dy > 0) then
			player.pic = p1
		end	
	end
	
	player.x,player.y,player.xvel,player.yvel = map_col(player.x,player.y,player.xvel,player.yvel,dt)
	player.x,player.y,player.xvel,player.yvel = hitbox_col(player.x,player.y,player.xvel,player.yvel,dt)

	-- Update position
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	
	--Shooting
	
	if(player.wep[player.wepSel] ~= 0) then
		fireRate = guns[player.wep[player.wepSel]].fireRate
	end
	
	if(cooldown <= 0) then
		if(love.mouse.isDown("l") and player.wep[player.wepSel] ~= 0) then
			shoot(player.wep[player.wepSel])
			cooldown = fireRate
		end
	else
		cooldown = cooldown - 1 * dt
	end
	
	-- Enemy Bullets
	for i,v in ipairs(enBullets) do
		if(v.dx ~= 0 and v.dy ~= 0) then
			if(CheckCollision(v.x,v.y,10,10,player.x-16,player.y-26,32,52)) then
				local dx = math.cos(v.angle) * enBulKnock
				local dy = math.sin(v.angle) * enBulKnock
				player.xvel = player.xvel + dx
				player.yvel = player.yvel + dy
				player.hp = player.hp - 1
				blood_splat(player.x,player.y,5,{v.angle-0.5,v.angle+0.5})
				parts_add(v.x,v.y,10,10,5,{v.angle+0.5,v.angle-0.5},800,{0.2,0.4},{0,200,0})
				table.remove(enBullets,i)
			end
		end
	end
	
	-- Bullets
	for i,v in ipairs(bullets) do
		if(v.dx ~= 0 and v.dy ~= 0) then
			v.x = v.x + v.dx * dt
			v.y = v.y + v.dy * dt
			
			local lastdy = v.dy
			local lastdx = v.dx
			v.x,v.y,v.dx,v.dy = map_col(v.x,v.y,v.dx,v.dy,dt)
			v.x,v.y,v.dx,v.dy = hitbox_col(v.x,v.y,v.dx,v.dy,dt)
			
			if(lastdx ~= v.dx or lastdy ~= v.dy) then
			parts_add(v.x,v.y,10,10,10,{v.angle+3.54,v.angle+2.6},800,{0.2,0.4},{100,100,100})
			end
			
			if(v.timer <= 0) then
				--removeTrail(bullets[i])
				v.removeTrail = true
				table.remove(bullets,i)
			else
				v.timer = v.timer - 1 * dt
			end
		else
			v.removeTrail = true
		end
	end
	
	if(player.hp < 0) then
		state = "gameover"
	end
end

local bulSpeed = 400
local bulImg = love.graphics.newImage("gfx/bullet.png")
local bulImg2 = love.graphics.newImage("gfx/bullet2.png")


function shoot(gun)
	for i=1,guns[gun].spread do
		bu = {}
		bu.x = player.x + player.w/2 - 5
		bu.y = player.y
		local tx = love.mouse.getX() - cam.x 
		local ty = love.mouse.getY() - cam.y
		local acc = math.random(-(guns[gun].accuracy * 2*math.pi) * 1000,(guns[gun].accuracy * 2*math.pi)*1000)/1000
		bu.angle = math.atan2((ty - bu.y),(tx - bu.x)) + (acc/2)
		
		bu.dx = math.cos(bu.angle) * guns[gun].bulSpeed
		bu.dy = math.sin(bu.angle) * guns[gun].bulSpeed
		
		bu.timer = 3
		
		parts_add(player.x,player.y,5,5,5,{bu.angle-0.2,bu.angle+0.2},600,{0.2,0.3},{220,100,0})
		shell_add(player.x,player.y,bu.angle + 1.57)
		bu.removeTrail = false
		table.insert(bullets,bu)
		add_trails(0,0,5,10,10,bullets[#bullets])
		
		local dx = bu.dx/bulSpeed
		local dy = bu.dy/bulSpeed
		add_flash(bu.x + dx*20,bu.y + dy*20,10,50,0.2)
		

		
		player.xvel = player.xvel - dx*guns[gun].knockback
		player.yvel = player.yvel - dy*guns[gun].knockback	
	end
	
	local s = guns[gun].shake
	cam.x = cam.x + math.random(-s,s)
	cam.y = cam.y + math.random(-s,s)
	local r = math.random(1,3)
	if(r == 1) then
		love.audio.play(s1)
	elseif(r == 2) then
		love.audio.play(s2)
	else
		love.audio.play(s3)
	end
	
	
end

function player_keypress(key)
	if(key == "q") then
		if(player.wepSel == 1) then
			player.wepSel = 2
		else
			player.wepSel = 1
		end	
	elseif(key == "e") then
		for i,v in ipairs(weps) do
			local dobreak = false
			if(CheckCollision(player.x-16,player.y-26,32,52,v.x,v.y,50,100)) then
				--wep_drop(player.x,player.y,player.wep[player.wepSel])
				if(player.wep[player.wepSel] ~= 0) then
					local a = mouse_angle()
					wep_drop(player.x,player.y,a,300,player.wep[player.wepSel])
				end
				player.wep[player.wepSel] = v.wepNum
				table.remove(weps,i)
				dobreak = true
			end
			if(dobreak == true) then
				break
			end
		end
	elseif(key == "lshift" and player.wep[player.wepSel] ~= 0) then
		local a = mouse_angle()
		wep_drop(player.x,player.y,a,800,player.wep[player.wepSel])
		player.wep[player.wepSel] = 0
		--player.wepSel = 1
	elseif(key == "lctrl") then
		if(player.wepSel == 1) then
			if(player.wep[2] ~= 0) then
				local a = mouse_angle()
				wep_drop(player.x,player.y,a,800,player.wep[2])
				player.wep[2] = 0			
			end
		elseif(player.wep[1] ~= 0) then
			local a = mouse_angle()
			wep_drop(player.x,player.y,a,800,player.wep[1])
			player.wep[2] = 0		
		end
	
	end
end

function player_mousepress(x,y,button)
	if(button == "wu") then
		if(player.wepSel == 1) then
			player.wepSel = 2
		else
			player.wepSel = 1
		end
		--player.wep = player.wep + 1
	elseif(button == "wd") then
		if(player.wepSel == 1) then
			player.wepSel = 2
		else
			player.wepSel = 1
		end
	end
end


player.pic = p1

gun = love.graphics.newImage("gfx/gun.png")
local arm = love.graphics.newImage("gfx/arm.png")
function player_draw()
	--love.graphics.rectangle("fill",player.x,player.y,player.w,player.h)
	local armx = player.x - 4
	local army = player.y - 10
	if(player.pic == p2 or player.pic == p4) then
		--love.graphics.draw(gun,player.x,player.y-10,mouse_angle(),1,1,0,5)
		if(player.pic == p2) then
			armx = player.x + 4
			army = player.y - 10
		else
			armx = player.x+4
			army = player.y - 10		
		end
		love.graphics.draw(arm,armx,army,mouse_angle(),1,1,0,2)
		love.graphics.draw(player.pic,player.x-16,player.y-26)
	else
		love.graphics.draw(player.pic,player.x-16,player.y-26)
		
		if(player.pic == p1) then
			armx = player.x - 4
			army = player.y - 14	
		elseif(player.pic == p3) then
			armx = player.x - 4
			army = player.y - 10		
		elseif(player.pic == p4) then
			
		end
		love.graphics.draw(arm,armx,army,mouse_angle(),1,1,0,2)
		
		--love.graphics.draw(gun,player.x,player.y-10,mouse_angle(),1,1,0,5)
		love.graphics.draw(arm,armx,army,mouse_angle(),1,1,0,2)
	end
	
	
	local by = player.y
	local bx = player.x + player.w/2 - 5
	local tx = love.mouse.getX() - cam.x
	local ty = love.mouse.getY() - cam.y
	
	local a = math.atan2((ty - by),(tx - bx))
	
	local dx = math.cos(a) * 20
	local dy = math.sin(a) * 20
	love.graphics.rectangle("fill",bx + dx -5/2,by + dy,5,5)
	
	for i,v in ipairs(bullets) do
		if(v.x > -cam.x and v.x < -cam.x + screen.w and v.y > -cam.y and v.y < -cam.y + screen.h) then
		--love.graphics.rectangle("fill",v.x,v.y,10,10)
			
			if(v.dx~=0 and v.dy ~= 0) then
				love.graphics.draw(bulImg2,v.x,v.y,v.angle,1,1,10,5)
				--love.graphics.circle("fill",v.x + cam.x,v.y + cam.y,50 - amb)
				love.graphics.draw(lightImg,v.x-12,v.y-12)
			else
				love.graphics.draw(bulImg,v.x,v.y,v.angle,1,1,10,5)
			end
		end
	end
	
	if(showPhrase == true) then
		local tw = font1:getWidth(phrases[phrase])
		bubble_draw(player.x -tw/2 - 20,player.y-90,tw,40,phrases[phrase])
	end
	
	--los_draw(player.x,player.y)
	los(player.x,player.y,400,400)
end

function player_HUD()
	local tw = font1:getWidth(""..player.wep[player.wepSel])
	love.graphics.print(player.wep[player.wepSel], screen.w -tw- 10, 25)
	
	love.graphics.setFont(font2)
	local text = (score.." X "..combo)
	local tw = font2:getWidth(text)
	love.graphics.print(text,screen.w/2-tw/2,screen.h - 50)
	
	love.graphics.setFont(font1)
	local timeTarget = 50+10*floorNum
	local text = ("Time: "..math.floor(gameTime).." - "..timeTarget)
	local tw = font1:getWidth(text)
	love.graphics.print(text,screen.w-tw-10,screen.h - 45)
	if(gameTime < timeTarget) then
		local tbonus = ((50+10*floorNum) - gameTime)*100
		text = ("Time Bonus: "..math.floor(tbonus))
	else
		text = "Too slow!"
	end
	local tw = font1:getWidth(text)
	love.graphics.print(text,screen.w-tw-10,screen.h - 25)
	
	
	local text = "Floor: "..floorNum
	local tw = font1:getWidth(text)
	love.graphics.print(text,screen.w-tw-10,10)
	
	love.graphics.setColor(200,0,0)
	for i=0,player.hp-1 do -- HP bar
		love.graphics.rectangle("fill",155 + 22 * i, screen.h - 75,20,30)
	end
	love.graphics.setColor(255,255,255)
	
	local tvel = math.abs(player.xvel) + math.abs(player.yvel) -- Speed bar
	for i=0,math.floor(tvel/100) -1 do
		if(i/40 * 255 < 255) then
			love.graphics.setColor(0,0,i/40 * 255)
		else
			love.graphics.setColor(0,0,255)
		end
		love.graphics.rectangle("fill",155 + i * 22,screen.h - 40,20,30)
	end
	love.graphics.setColor(255,255,255)
	love.graphics.setColor(0,0,100,200)
	love.graphics.rectangle("fill",10,screen.h - 90,80,80) -- selected
	love.graphics.rectangle("fill",100, screen.h - 50,40,40) -- secondary
	love.graphics.setColor(255,255,255)
	if(player.wep[player.wepSel] ~= 0) then
		love.graphics.draw(guns[player.wep[player.wepSel]].icon,10,screen.h - 90)
	end

	if(player.wepSel == 1) then
		if(player.wep[2] ~= 0) then
			love.graphics.draw(guns[player.wep[2]].icon,110,screen.h - 60,0.5,0.5)
		end
	elseif(player.wep[1] ~= 0) then
		love.graphics.draw(guns[player.wep[1]].icon,110, screen.h - 60,0.5,0.5)
	end
	--bubble_draw(100,100,200,40,"Sup")
end

local c1 = love.graphics.newImage("gfx/corner.png")
local t1 = love.graphics.newImage("gfx/top.png")
local tip = love.graphics.newImage("gfx/tip.png")

function bubble_draw(x,y,w,h,text)
	x = math.floor(x)
	y = math.floor(y)
	w = math.floor(w)
	h = math.floor(h)
	love.graphics.draw(c1,x,y) -- top left
	love.graphics.draw(c1,x,y+h,0,1,-1) -- bot left
	love.graphics.draw(c1,x+w+40,y,0,-1,1) -- top right
	love.graphics.draw(c1,x+w+40,y+h,0,-1,-1) -- bot right
	love.graphics.draw(t1,x+20,y,0,w,1)
	love.graphics.draw(t1,x+20,y+h,0,w,-1)
	love.graphics.draw(tip,x+w/2-10+20,y+h-2)
	love.graphics.setColor(0,0,0)
	local k = font1:getWidth(text)
	love.graphics.print(text,20+ x+w/2 - k/2,y+15)
	love.graphics.setColor(255,255,255)
end

function los(x1,y1,x2,y2)
	local dt = love.timer.getDelta()
	local dist = math.floor(CheckDist(x1,y1,x2,y2)/10)
	local a = math.atan2((y1-y2),(x1-x2)) + 3.14
	local dx = math.cos(a)
	local dy = math.sin(a)
	local draw = true
	
	for i=1,dist do
		if(draw == true) then
			local x = x1+dx*i*10
			local y = y1+dy*i*10
			local ldx = dx
			local ldy = dy
			x,y,dx,dy = map_col(x,y,dx,dy,dt)
			if(x ~= x1+ldx*i*10 or y ~= y1+ldy*i*10) then
				draw = false
			end
		end
	end
	if(draw == true) then
		return true
	else
		return false
	end
end

function los_draw(x1,y1)
	local dt = love.timer.getDelta()

	local a = mouse_angle()
	local dx = math.cos(a)
	local dy = math.sin(a)
	local draw = true
	
	for i=1,400 do
		local x = x1+dx*i*10
		local y = y1+dy*i*10
		local ldx = dx
		local ldy = dy
		x,y,dx,dy = map_col(x,y,dx,dy,dt)
		if(x ~= x1+ldx*i*10 or y ~= y1+ldy*i*10) then
			draw = false
		end

		if(draw == true) then
			love.graphics.rectangle("fill",x,y,10,10)
			--love.graphics.print(dx,x,y)
		end
	end
end
